--- old/exception_lists/check_rtime	2019-07-14 19:11:50.231083091 +0000
+++ new/exception_lists/check_rtime	2019-07-14 19:11:50.250611957 +0000
@@ -251,3 +251,11 @@
 # one size fits all approach causes an object to be linked against an
 # unneeded library.
 UNREF_OBJ	lib/(libdevinfo|libcfgadm)\.so\.1; .*\ of\ .*SUNW,Netra-CP2300/lib/libprtdiag_psr\.so\.1
+
+#
+# the SUNWonld directory contains built versions of demos, built only to
+# ensure their correctness.
+#
+EXEC_STACK	^opt/SUNWonld
+EXEC_DATA	^opt/SUNWonld
+NODIRECT	^opt/SUNWonld
--- old/exception_lists/packaging	2019-07-14 19:11:50.779034321 +0000
+++ new/exception_lists/packaging	2019-07-14 19:11:50.796867444 +0000
@@ -858,3 +858,29 @@
 usr/lib/amd64/libjedec.so	i386
 usr/lib/sparcv9/libjedec.so	sparc
 usr/lib/libjedec.so
+
+#
+# the tools copy of the link-editor is not delivered
+#
+opt/onbld/bin/i386/ld			i386
+opt/onbld/bin/sparc/ld			sparc
+opt/onbld/bin/i386/sgsmsg		i386
+opt/onbld/bin/sparc/sgsmsg		sparc
+opt/onbld/lib/i386/libelf.so		i386
+opt/onbld/lib/i386/libelf.so.1		i386
+opt/onbld/lib/i386/libld.so		i386
+opt/onbld/lib/i386/libld.so.4		i386
+opt/onbld/lib/i386/liblddbg.so		i386
+opt/onbld/lib/i386/liblddbg.so.4	i386
+opt/onbld/lib/sparc/libelf.so		sparc
+opt/onbld/lib/sparc/libelf.so.1		sparc
+opt/onbld/lib/sparc/libld.so		sparc
+opt/onbld/lib/sparc/libld.so.4		sparc
+opt/onbld/lib/sparc/liblddbg.so		sparc
+opt/onbld/lib/sparc/liblddbg.so.4	sparc
+opt/onbld/man/man1onbld/sgsmsg.1onbld
+
+#
+# The built link-editor demos are not delivered
+#
+opt/SUNWonld/
--- old/usr/src/Makefile.master	2019-07-14 19:11:51.294076478 +0000
+++ new/usr/src/Makefile.master	2019-07-14 19:11:51.310865772 +0000
@@ -850,6 +850,7 @@
 CW_CC_COMPILERS=	$(PRIMARY_CC:%=--primary %) $(SHADOW_CCS:%=--shadow %)
 CW_CCC_COMPILERS=	$(PRIMARY_CCC:%=--primary %) $(SHADOW_CCCS:%=--shadow %)
 
+CW_LINKER=		--linker $(LD)
 
 # Till SS12u1 formally becomes the NV CBE, LINT is hard
 # coded to be picked up from the $SPRO_ROOT/sunstudio12.1/
@@ -863,10 +864,10 @@
 #
 CW=			$(ONBLD_TOOLS)/bin/$(MACH)/cw
 
-BUILD_CC=		$(CW) $(CW_CC_COMPILERS) --
-BUILD_CCC=		$(CW) -C $(CW_CCC_COMPILERS) --
+BUILD_CC=		$(CW) $(CW_LINKER) $(CW_CC_COMPILERS) --
+BUILD_CCC=		$(CW) -C $(CW_LINKER) $(CW_CCC_COMPILERS) --
 BUILD_CPP=		/usr/ccs/lib/cpp
-BUILD_LD=		/usr/ccs/bin/ld
+BUILD_LD=		$(ONBLD_TOOLS)/bin/$(MACH)/ld
 BUILD_LINT=		$(SPRO_ROOT)/sunstudio12.1/bin/lint
 
 $(MACH)_CC=		$(BUILD_CC)
--- old/usr/src/cmd/sgs/Makefile	2019-07-14 19:11:51.770402997 +0000
+++ new/usr/src/cmd/sgs/Makefile	2019-07-14 19:11:51.785710231 +0000
@@ -115,7 +115,7 @@
 
 .PARALLEL:	$(SUBDIRS)
 
-all install:	native-add .WAIT $(SUBDIRS)
+all install:	$(SUBDIRS)
 
 include		$(SRC)/cmd/Makefile.targ
 
@@ -125,8 +125,7 @@
 
 _msg_gettext: $(MSGDOMAIN)/$(POFILE)
 
-# $(MACH)/sgsmsg must be built before we can descend into $(MSGDIR)
-_msg_sgsmsg: native-add .WAIT $(MSGDIR)
+_msg_sgsmsg: $(MSGDIR)
 
 $(MSGDOMAIN)/$(POFILE): \
 		$(MSGDOMAIN) $(POFILE)
@@ -149,39 +148,18 @@
 
 lint:
 
-delete \
-clean clobber:	native-clobber .WAIT $(SUBDIRS) $(MSGDIR)
+delete clean clobber: $(SUBDIRS) $(MSGDIR)
 
 $(SUBDIRS):	FRC
 		@ cd $@; pwd; $(MAKE) $(TARGET)
 
-
-# Integration of ld and ld.so.1 in some developement cycles requires that both
-# of these modules be built using the new ld.  This `native' target allows us
-# to build a local ld which will then be used to build the delivered version of
-# itself and ld.so.1.  Once this new functionality appears in the standard ld
-# this target can be disabled.
-
-native-add:	FRC
-		@ cd tools/$(MACH); pwd; $(MAKE) native
-		@ cd libconv/$(MACH); pwd; $(MAKE)
-		@ cd libelf/$(MACH); pwd; $(MAKE) native
-		@ cd liblddbg/$(MACH); pwd; $(MAKE) native
-		@ cd libldstab/$(MACH); pwd; $(MAKE) native
-		@ cd libld/$(MACH); pwd; $(MAKE) native
-		@ cd ld/$(MACH); pwd; $(MAKE) native
-
-native-clobber:
-		@ cd tools; pwd; $(MAKE) $(TARGET)
-		$(RM) -r proto/$(MACH)
-
 FRC:
 
 #
 # Cross-reference customization: ignore the directories named by XRPRUNE,
 # and tweak the file globs slightly.
 #
-XRPRUNE=	rtld.4.x packages abi
+XRPRUNE=	rtld.4.x abi
 XRADD=		*.msg mapfile*
 XRDEL=		Makefile* kobj_*
 
--- old/usr/src/cmd/sgs/Makefile.com	2019-07-14 19:11:52.241304346 +0000
+++ new/usr/src/cmd/sgs/Makefile.com	2019-07-14 19:11:52.257766105 +0000
@@ -31,8 +31,6 @@
 
 include		$(SRC)/cmd/sgs/Makefile.var
 
-SRCBASE =	../../../..
-
 i386_ARCH =	intel
 sparc_ARCH =	sparc
 
@@ -52,6 +50,8 @@
 CFLAGS +=	$(CCVERBOSE) $(DEBUG) $(XFFLAG)
 CFLAGS64 +=	$(CCVERBOSE) $(DEBUG) $(XFFLAG)
 
+NATIVE_CFLAGS +=	$(CCVERBOSE) $(DEBUG) $(XFFLAG)
+
 CERRWARN +=	-_gcc=-Wno-type-limits
 CERRWARN +=	-_gcc=-Wno-parentheses
 CERRWARN +=	-_gcc=-Wno-unused-value
@@ -63,7 +63,7 @@
 
 # Reassign CPPFLAGS so that local search paths are used before any parent
 # $ROOT paths.
-CPPFLAGS =	-I. -I../common -I../../include -I../../include/$(MACH) \
+CPPFLAGS =	-I. -I../common -I$(SGSHOME)/include -I$(SGSHOME)/include/$(MACH) \
 		$(CPPFLAGS.master) -I$(ELFCAP)
 
 # PICS64 is unique to our environment
@@ -77,7 +77,7 @@
 # Establish the local tools, proto and package area.
 
 SGSHOME =	$(SRC)/cmd/sgs
-SGSPROTO =	$(SGSHOME)/proto/$(MACH)
+SGSCOMMON =	$(SGSHOME)/common
 SGSTOOLS =	$(SGSHOME)/tools
 SGSMSGID =	$(SGSHOME)/messages
 SGSMSGDIR =	$(SGSHOME)/messages/$(MACH)
@@ -85,12 +85,6 @@
 SGSRPATH =	/usr/lib
 SGSRPATH64 =	$(SGSRPATH)/$(MACH64)
 
-# Mimic the structure of an installed system.
-
-SGSLIBDIR =	$(SGSPROTO)/lib
-SGSPREFIX =	$(SGSPROTO)/usr
-SGSBINDIR =	$(SGSPREFIX)/bin
-
 #
 # Macros to be used to include link against libconv and include vernote.o
 #
@@ -117,33 +111,10 @@
 # Define any generic sgsmsg(1l) flags.  The default message generation system
 # is to use gettext(3i), add the -C flag to switch to catgets(3c).
 
-SGSMSG =		$(SGSTOOLS)/$(MACH)/sgsmsg
+SGSMSG =		$(ONBLD_TOOLS)/bin/$(MACH)/sgsmsg
 SGSMSG_PIGLATIN_NL =	perl $(SGSTOOLS)/common/sgsmsg_piglatin_nl.pl
-CHKMSG =		$(SGSTOOLS)/chkmsg.sh
+CHKMSG =		$(SGSHOME)/tools/chkmsg.sh
 
 SGSMSGVFLAG =
 SGSMSGFLAGS =	$(SGSMSGVFLAG) -i $(SGSMSGID)/sgs.ident
 CHKMSGFLAGS =	$(SGSMSGTARG:%=-m %) $(SGSMSGCHK:%=-m %)
-
-# Native targets should use the minimum of ld(1) flags to allow building on
-# previous releases.  We use mapfiles to scope, but don't bother versioning.
-
-native :=	DYNFLAGS = -R$(SGSLIBDIR) -L$(SGSLIBDIR) $(ZNOVERSION) \
-			$(HSONAME)
-
-# Comment out the following two lines to have the sgs built from the system
-# link-editor, rather than the local proto link-editor.
-CC_USE_PROTO =	-Yl,$(SGSBINDIR)
-LD_USE_PROTO =	$(SGSBINDIR)/
-
-LD_LIB =	-lld
-LD_LIB32 =	-lld32
-LD_LIB64 =	-lld64
-
-LDDBG_LIB =	-llddbg
-LDDBG_LIB32 =	-llddbg32
-LDDBG_LIB64 =	-llddbg64
-
-CONV_LIB =	-lconv
-CONV_LIB32 =	-lconv32
-CONV_LIB64 =	-lconv64
--- old/usr/src/cmd/sgs/Makefile.targ	2019-07-14 19:11:52.609042055 +0000
+++ new/usr/src/cmd/sgs/Makefile.targ	2019-07-14 19:11:52.625563623 +0000
@@ -51,19 +51,4 @@
 $(ROOTFS_LIBDIR64)/$(LIBLINKSCCC): $(ROOTFS_LIBDIR64)/$(LIBLINKSCCC)$(VERS)
 	$(INS.liblinkccc64)
 
-#
-# For those that install into the SGSPROTO directory.
-#
-$(SGSPROTO):
-	$(INS.dir)
-
-$(SGSBINDIR): $(SGSPROTO)
-	$(INS.dir)
-
-$(SGSPREFIX): $(SGSPROTO)
-	$(INS.dir)
-
-$(SGSLIBDIR): $(SGSPREFIX)
-	$(INS.dir)
-
 FRC:
--- old/usr/src/cmd/sgs/Makefile.var	2019-07-14 19:11:53.053628990 +0000
+++ new/usr/src/cmd/sgs/Makefile.var	2019-07-14 19:11:53.071166839 +0000
@@ -69,8 +69,8 @@
 # files avl.c, avl.h and avl_impl.h until these files are back ported into
 # the system.
 #
-VAR_AVLDIR=		$(SRCBASE)/common/avl
-VAR_AVLINCDIR=		-I $(SRCBASE)/uts/common
+VAR_AVLDIR=		$(SRC)/common/avl
+VAR_AVLINCDIR=		-I $(SRC)/uts/common
 
 #
 # VAR_DTRDIR - directory to find dtrace_data.c in.
@@ -78,7 +78,7 @@
 # In Solaris 10 and earlier releases, dtrace_data.c was maintained as separate
 # files under sgs/rtld.  This file is now under usr/src/common/dtrace.
 #
-VAR_DTRDIR=             $(SRCBASE)/common/dtrace
+VAR_DTRDIR=             $(SRC)/common/dtrace
 
 #
 # VAR_SGSBINPROG
--- old/usr/src/cmd/sgs/ar/Makefile.com	2019-07-14 19:11:53.521128127 +0000
+++ new/usr/src/cmd/sgs/ar/Makefile.com	2019-07-14 19:11:53.538784317 +0000
@@ -47,7 +47,7 @@
 
 SMOFF += signed
 
-LDLIBS +=	-lelf $(CONVLIBDIR) $(CONV_LIB) -lsendfile
+LDLIBS +=	-lelf $(CONVLIBDIR) -lconv -lsendfile
 
 $(XPG4) :=	CPPFLAGS += -DXPG4
 
@@ -63,6 +63,6 @@
 
 SGSMSGFLAGS +=	-h $(BLTDEFS) -d $(BLTDATA) -m $(BLTMESG) -n ar_msg
 
-SRCS=		$(COMOBJ:%.o=../common/%.c) $(BLTDATA:%.o=$(SGSTOOLS)/common/%.c)
+SRCS=		$(COMOBJ:%.o=../common/%.c) $(BLTDATA:%.o=$(SGSCOMMON)/%.c)
 
 CLEANFILES +=	$(BLTFILES)
--- /dev/null	2019-07-14 19:11:50.000000000 +0000
+++ new/usr/src/cmd/sgs/common/alist.c	2019-07-14 19:11:54.005390270 +0000
@@ -0,0 +1,465 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+#include <sgs.h>
+#include <string.h>
+#include <stdio.h>
+#include <sys/debug.h>
+
+/*
+ * Alist manipulation.  An Alist is a list of elements formed into an array.
+ * Traversal of the list is an array scan, which because of the locality of
+ * each reference is probably more efficient than a link-list traversal.
+ *
+ * See alist.h for more background information about array lists.
+ */
+
+/*
+ * Insert a value into an array at a specified index:
+ *
+ *	alist_insert(): Insert an item into an Alist at the specified index
+ *	alist_insert_by_offset(): Insert an item into an Alist at the
+ *		specified offset relative to the list address.
+ *	aplist_insert() Insert a pointer into an APlist at the specified index
+ *
+ * entry:
+ *	Note: All the arguments for all three routines are listed here.
+ *	The routine to which a given argument applies is given with
+ *	each description.
+ *
+ *	llp [all] - Address of a pointer to an Alist/APlist. The pointer should
+ *		be initialized to NULL before its first use.
+ *	datap [alist_insert / aplist_insert] - Pointer to item data, or
+ *		NULL. If non-null the data referenced is copied into the
+ *		Alist item. Otherwise, the list item is zeroed, and
+ *		further initialization is left to the caller.
+ *	ptr [aplist_insert] - Pointer to be inserted.
+ *	size [alist_insert / alist_insert_by_offset] - Size of an item
+ *		in the array list, in bytes. As with any array, A given
+ *		Alist can support any item size, but every item in that
+ *		list must have the same size.
+ *	init_arritems [all] - Initial allocation size: On the first insertion
+ *		into the array list, room for init_arritems items is allocated.
+ *	idx [alist_insert / aplist_insert] - Index at which to insert the
+ *		new item. This index must lie within the existing list,
+ *		or be the next index following.
+ *	off [alist_insert_by_offset] - Offset at which  to insert the new
+ *		item, based from the start of the Alist. The offset of
+ *		the first item is ALIST_OFF_DATA.
+ *
+ * exit:
+ *	The item is inserted at the specified position. This operation
+ *	can cause memory for the list to be allocated, or reallocated,
+ *	either of which will cause the value of the list pointer
+ *	to change.
+ *
+ *	These routines can only fail if unable to allocate memory,
+ *	in which case NULL is returned.
+ *
+ *	If a pointer list (aplist_insert), then the pointer
+ *	is stored in the requested index. On success, the address
+ *	of the pointer within the list is returned.
+ *
+ *	If the list contains arbitrary data (not aplist_insert): If datap
+ *	is non-NULL, the data it references is copied into the item at
+ *	the index. If datap is NULL, the specified item is zeroed.
+ *	On success, a pointer to the inserted item is returned.
+ *
+ *	The  caller must not retain the returned pointer from this
+ *	routine across calls to the list module. It is only safe to use
+ *	it until the next call to this module for the given list.
+ *
+ */
+void *
+alist_insert(Alist **lpp, const void *datap, size_t size,
+    Aliste init_arritems, Aliste idx)
+{
+	Alist	*lp = *lpp;
+	char	*addr;
+
+	/* The size and initial array count need to be non-zero */
+	ASSERT(init_arritems != 0);
+	ASSERT(size != 0);
+
+	if (lp == NULL) {
+		Aliste bsize;
+
+		/*
+		 * First time here, allocate a new Alist.  Note that the
+		 * Alist al_desc[] entry is defined for 1 element,
+		 * but we actually allocate the number we need.
+		 */
+		bsize = size * init_arritems;
+		bsize = S_ROUND(bsize, sizeof (void *));
+		bsize = ALIST_OFF_DATA + bsize;
+		if ((lp = malloc((size_t)bsize)) == NULL)
+			return (NULL);
+		lp->al_arritems = init_arritems;
+		lp->al_nitems = 0;
+		lp->al_next = ALIST_OFF_DATA;
+		lp->al_size = size;
+		*lpp = lp;
+	} else {
+		/* We must get the same value for size every time */
+		ASSERT(size == lp->al_size);
+
+		if (lp->al_nitems >= lp->al_arritems) {
+			/*
+			 * The list is full: Increase the memory allocation
+			 * by doubling it.
+			 */
+			Aliste	bsize;
+
+			bsize = lp->al_size * lp->al_arritems * 2;
+			bsize = S_ROUND(bsize, sizeof (void *));
+			bsize = ALIST_OFF_DATA + bsize;
+			if ((lp = realloc((void *)lp, (size_t)bsize)) == 0)
+				return (NULL);
+			lp->al_arritems *= 2;
+			*lpp = lp;
+		}
+	}
+
+	/*
+	 * The caller is not supposed to use an index that
+	 * would introduce a "hole" in the array.
+	 */
+	ASSERT(idx <= lp->al_nitems);
+
+	addr = (idx * lp->al_size) + (char *)lp->al_data;
+
+	/*
+	 * An appended item is added to the next available array element.
+	 * An insert at any other spot requires that the data items that
+	 * exist at the point of insertion be shifted down to open a slot.
+	 */
+	if (idx < lp->al_nitems)
+		(void) memmove(addr + lp->al_size, addr,
+		    (lp->al_nitems - idx) * lp->al_size);
+
+	lp->al_nitems++;
+	lp->al_next += lp->al_size;
+	if (datap != NULL)
+		(void) memcpy(addr, datap, lp->al_size);
+	else
+		(void) memset(addr, 0, lp->al_size);
+	return (addr);
+}
+
+void *
+alist_insert_by_offset(Alist **lpp, const void *datap, size_t size,
+    Aliste init_arritems, Aliste off)
+{
+	Aliste idx;
+
+	if (*lpp == NULL) {
+		ASSERT(off == ALIST_OFF_DATA);
+		idx = 0;
+	} else {
+		idx = (off - ALIST_OFF_DATA) / (*lpp)->al_size;
+	}
+
+	return (alist_insert(lpp, datap, size, init_arritems, idx));
+}
+
+void *
+aplist_insert(APlist **lpp, const void *ptr, Aliste init_arritems, Aliste idx)
+{
+	APlist	*lp = *lpp;
+
+	/* The initial array count needs to be non-zero */
+	ASSERT(init_arritems != 0);
+
+	if (lp == NULL) {
+		Aliste bsize;
+
+		/*
+		 * First time here, allocate a new APlist.  Note that the
+		 * APlist apl_desc[] entry is defined for 1 element,
+		 * but we actually allocate the number we need.
+		 */
+		bsize = APLIST_OFF_DATA + (sizeof (void *) * init_arritems);
+		if ((lp = malloc((size_t)bsize)) == NULL)
+			return (NULL);
+		lp->apl_arritems = init_arritems;
+		lp->apl_nitems = 0;
+		*lpp = lp;
+	} else if (lp->apl_nitems >= lp->apl_arritems) {
+		/*
+		 * The list is full: Increase the memory allocation
+		 * by doubling it.
+		 */
+		Aliste	bsize;
+
+		bsize = APLIST_OFF_DATA +
+		    (2 * sizeof (void *) * lp->apl_arritems);
+		if ((lp = realloc((void *)lp, (size_t)bsize)) == 0)
+			return (NULL);
+		lp->apl_arritems *= 2;
+		*lpp = lp;
+	}
+
+	/*
+	 * The caller is not supposed to use an index that
+	 * would introduce a "hole" in the array.
+	 */
+	ASSERT(idx <= lp->apl_nitems);
+
+	/*
+	 * An appended item is added to the next available array element.
+	 * An insert at any other spot requires that the data items that
+	 * exist at the point of insertion be shifted down to open a slot.
+	 */
+	if (idx < lp->apl_nitems)
+		(void) memmove((char *)&lp->apl_data[idx + 1],
+		    (char *)&lp->apl_data[idx],
+		    (lp->apl_nitems - idx) * sizeof (void *));
+
+	lp->apl_nitems++;
+	lp->apl_data[idx] = (void *)ptr;
+	return (&lp->apl_data[idx]);
+}
+
+/*
+ * Append a value to a list. These are convenience wrappers on top
+ * of the insert operation. See the description of those routine above
+ * for details.
+ */
+void *
+alist_append(Alist **lpp, const void *datap, size_t size,
+    Aliste init_arritems)
+{
+	Aliste ndx = ((*lpp) == NULL) ? 0 : (*lpp)->al_nitems;
+
+	return (alist_insert(lpp, datap, size, init_arritems, ndx));
+}
+
+void *
+aplist_append(APlist **lpp, const void *ptr, Aliste init_arritems)
+{
+	Aliste ndx = ((*lpp) == NULL) ? 0 : (*lpp)->apl_nitems;
+
+	return (aplist_insert(lpp, ptr, init_arritems, ndx));
+}
+
+/*
+ * Delete the item at a specified index/offset, and decrement the variable
+ * containing the index:
+ *
+ *	alist_delete - Delete an item from an Alist at the specified
+ *		index.
+ *	alist_delete_by_offset - Delete an item from an Alist at the
+ *		specified offset from the list pointer.
+ *	aplist_delete - Delete a pointer from an APlist at the specified
+ *		index.
+ *
+ * entry:
+ *	alp - List to delete item from
+ *	idxp - Address of variable containing the index of the
+ *		item to delete.
+ *	offp - Address of variable containing the offset of the
+ *		item to delete.
+ *
+ * exit:
+ *	The item at the position given by (*idxp) or (*offp), depending
+ *	on the routine, is removed from the list. Then, the position
+ *	variable (*idxp or *offp) is decremented by one item. This is done
+ *	to facilitate use of this routine within a TRAVERSE loop.
+ *
+ * note:
+ *	Deleting the last element in an array list is cheap, but
+ *	deleting any other item causes a memory copy to occur to
+ *	move the following items up. If you intend to traverse the
+ *	entire list, deleting every item as you go, it will be cheaper
+ *	to omit the delete within the traverse, and then call
+ *	the reset function reset() afterwards.
+ */
+void
+alist_delete(Alist *lp, Aliste *idxp)
+{
+	Aliste	idx = *idxp;
+
+
+	/* The list must be allocated and the index in range */
+	ASSERT(lp != NULL);
+	ASSERT(idx < lp->al_nitems);
+
+	/*
+	 * If the element to be removed is not the last entry of the array,
+	 * slide the following elements over the present element.
+	 */
+	if (idx < --lp->al_nitems) {
+		char *addr = (idx * lp->al_size) + (char *)lp->al_data;
+
+		(void) memmove(addr, addr + lp->al_size,
+		    (lp->al_nitems - idx) * lp->al_size);
+	}
+	lp->al_next -= lp->al_size;
+
+	/* Decrement the callers index variable */
+	(*idxp)--;
+}
+
+void
+alist_delete_by_offset(Alist *lp, Aliste *offp)
+{
+	Aliste idx;
+
+	ASSERT(lp != NULL);
+	idx = (*offp - ALIST_OFF_DATA) / lp->al_size;
+
+	alist_delete(lp, &idx);
+	*offp -= lp->al_size;
+}
+
+void
+aplist_delete(APlist *lp, Aliste *idxp)
+{
+	Aliste	idx = *idxp;
+
+
+	/* The list must be allocated and the index in range */
+	ASSERT(lp != NULL);
+	ASSERT(idx < lp->apl_nitems);
+
+	/*
+	 * If the element to be removed is not the last entry of the array,
+	 * slide the following elements over the present element.
+	 */
+	if (idx < --lp->apl_nitems)
+		(void) memmove(&lp->apl_data[idx], &lp->apl_data[idx + 1],
+		    (lp->apl_nitems - idx) * sizeof (void *));
+
+	/* Decrement the callers index variable */
+	(*idxp)--;
+}
+
+/*
+ * Delete the pointer with a specified value from the APlist.
+ *
+ * entry:
+ *	lp - Initialized APlist to delete item from
+ *	ptr - Pointer to be deleted.
+ *
+ * exit:
+ *	The list is searched for an item containing the given pointer,
+ *	and if a match is found, that item is delted and True (1) returned.
+ *	If no match is found, then False (0) is returned.
+ *
+ * note:
+ *	See note for delete operation, above.
+ */
+int
+aplist_delete_value(APlist *lp, const void *ptr)
+{
+	size_t	idx;
+
+	/*
+	 * If the pointer is found in the list, use aplist_delete to
+	 * remove it, and we're done.
+	 */
+	for (idx = 0; idx < lp->apl_nitems; idx++)
+		if (ptr == lp->apl_data[idx]) {
+			aplist_delete(lp, &idx);
+			return (1);
+		}
+
+	/* If we get here, the item was not in the list */
+	return (0);
+}
+
+/*
+ * Search the APlist for an element with a given value, and
+ * if not found, optionally append the element to the end of the list.
+ *
+ * entry:
+ *	lpp, ptr - As per aplist_insert().
+ *	init_arritems - As per aplist_insert() if a non-zero value.
+ *		A value of zero is special, and is taken to indicate
+ *		that no insert operation should be performed if
+ *		the item is not found in the list.
+ *
+ * exit
+ *	The given item is compared to every item in the given APlist.
+ *	If it is found, ALE_EXISTS is returned.
+ *
+ *	If it is not found: If init_arr_items is False (0), then
+ *	ALE_NOTFOUND is returned. If init_arr_items is True, then
+ *	the item is appended to the list, and ALE_CREATE returned on success.
+ *
+ *	On failure, which can only occur due to memory allocation failure,
+ *	ALE_ALLOCFAIL is returned.
+ *
+ * note:
+ *	The test operation used by this routine is a linear
+ *	O(N) operation, and is not efficient for more than a
+ *	few items.
+ */
+aplist_test_t
+aplist_test(APlist **lpp, const void *ptr, Aliste init_arritems)
+{
+	APlist	*lp = *lpp;
+	size_t	idx;
+
+	/* Is the pointer already in the list? */
+	if (lp != NULL)
+		for (idx = 0; idx < lp->apl_nitems; idx++)
+			if (ptr == lp->apl_data[idx])
+				return (ALE_EXISTS);
+
+	/* Is this a no-insert case? If so, report that the item is not found */
+	if (init_arritems == 0)
+		return (ALE_NOTFND);
+
+	/* Add it to the end of the list */
+	if (aplist_append(lpp, ptr, init_arritems) == NULL)
+		return (ALE_ALLOCFAIL);
+	return (ALE_CREATE);
+}
+
+/*
+ * Reset the given list to its empty state. Any memory allocated by the
+ * list is preserved, ready for reuse, but the list is set to its
+ * empty state, equivalent to having called the delete operation for
+ * every item.
+ *
+ * Note that no cleanup of the discarded items is done. The caller must
+ * take care of any necessary cleanup before calling aplist_reset().
+ */
+void
+alist_reset(Alist *lp)
+{
+	if (lp != NULL) {
+		lp->al_nitems = 0;
+		lp->al_next = ALIST_OFF_DATA;
+	}
+}
+
+void
+aplist_reset(APlist *lp)
+{
+	if (lp != NULL)
+		lp->apl_nitems = 0;
+}
--- /dev/null	2019-07-14 19:11:50.000000000 +0000
+++ new/usr/src/cmd/sgs/common/assfail.c	2019-07-14 19:11:54.236767497 +0000
@@ -0,0 +1,41 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License, Version 1.0 only
+ * (the "License").  You may not use this file except in compliance
+ * with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2003 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+#include <stdlib.h>
+#include <stdio.h>
+
+/*
+ * Provide assfail() for ASSERT() statements,
+ * see <sys/debug.h> for further details.
+ */
+int
+assfail(const char *a, const char *f, int l)
+{
+	(void) printf("assertion failed: %s, file: %s, line: %d\n",
+	    a, f, l);
+	abort();
+	return (0);
+}
--- /dev/null	2019-07-14 19:11:50.000000000 +0000
+++ new/usr/src/cmd/sgs/common/findprime.c	2019-07-14 19:11:54.725873170 +0000
@@ -0,0 +1,53 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License, Version 1.0 only
+ * (the "License").  You may not use this file except in compliance
+ * with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2003 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+#include <sys/types.h>
+
+/*
+ * function that will find a prime'ish number.  Usefull for
+ * hashbuckets and related things.
+ */
+uint_t
+findprime(uint_t count)
+{
+	uint_t	h, f;
+
+	if (count <= 3)
+		return (3);
+
+
+	/*
+	 * Check to see if divisible by two, if so
+	 * increment.
+	 */
+	if ((count & 0x1) == 0)
+		count++;
+
+	for (h = count, f = 2; f * f <= h; f++)
+		if ((h % f) == 0)
+			h += f = 1;
+	return (h);
+}
